'-------------------------------------------------------------------------------
'   Siemens S65   Lph88   Atmega128
'-------------------------------------------------------------------------------
'     12  ( be carefull ).
'
'                    LCD            AVR
'                    ---            ---
'                    1 /RS          B4
'                    2 /Reset       B3
'                    3 /CS          B2
'                    4 /CLK         B7
'                    5 /DAT         B5
'                    6 /Vcc        3 V (max.3.3 V, min.2.4 V)
'                    7 /GND        GND
'                    8 /Vdigital   3 Volt
'                    9 /LED+       12.0 V
'                    10/LED-       GND
'-------------------------------------------------------------------------------
'
'          Siemens S65    65
'       128,        
'-------------------------------------------------------------------------------
'                  Bascom-AVR 1.11.8./...
'-------------------------------------------------------------------------------
$regfile = "m128def.dat"                                    ' 128
$crystal = 16000000                                         ' 8 
'$baud = 115200                                              '   115200
'$xramsize = 65535
$hwstack = 128
$swstack = 128
$framesize = 128
'$xramsize = 65535
'$xramstart = &H1100
Set Mcucr.7
Wait 2
Ddrb = &B11111111                                           'b  
Disable Interrupts
Config Timer1 = Counter , Prescale = 1 , Compare A = Toggle '    
Set Tccr1b.wgm12
Set Tccr1b.wgm13
Menu_knop Alias Pine.2 : Reset Ddre.2
Sel Alias Pine.3 : Reset Ddre.3
Rs Alias Portb.0                                            '
Rst Alias Portb.4                                           '
Cs Alias Portb.6
Clk Alias Portb.1
Dat Alias Portb.2
Select_memory Alias Portb.7
Reset_memory Alias Portg.3 : Set Ddrg.3
Set Select_memory


Set Porte.2
Set Porte.3

'   /

Config Portd = Input
Config Portf = Input

On Int0 Data_reqest Nosave
On Int1 Hsyncro Nosave
On Int2 Kadr Nosave
Config Int0 = Falling
Config Int1 = Rising
Config Int2 = Rising

Const Buff1_write = &H84
Const Buff2_write = &H87
Const Buff1_mem_write = &H83
Const Buff2_mem_write = &H86
Const Current_page_read = &HD2
Const Current_page_write = &H82
'   
Const White = &HFFFF                                        ' 
Const Black = &H0000                                        '
Const Red = &HF800                                          '
Const Green = &H7C0                                         '
Const Blue = &H1F                                           '
Const Whiblu = &H7FF                                        '
Set Ddrd.7
Set Portd.7
Set Ddrd.6

Dim Buf(264) As Byte
Dim Page_mem As Word
'     
Dim A As Word , Aew As Word , Temp5 As Word
Dim Temp As Byte , Select_cadr As Bit
Dim Ae As Byte , Status(14) As Byte
Dim B As Byte , Dig As Word
Dim D As Byte , X As Byte , Color As Word , Fon As Word
Dim E As Byte , Buf_zikl As Word
Dim G As Word , Word_temp As Word
Dim F As Byte , Number_cadr As Word
Dim Symbol As String * 1
Dim C As Bit

Dim N As Byte , Temp1 As Word
Dim Sd As Bit
'Dim X As Byte
Dim X_end As Byte
Dim Y As Byte , End_cadr As Byte
Dim Y_end As Byte , U As Byte
'Dim Video_buf(31360) As Xram Byte At &H3000
'Dim Video_s(216) As Xram Byte At &H2000
'   
Declare Sub Clear_screen(byval Clear_color As Word)
Declare Sub Wordout()
Declare Sub Byteout()
Declare Sub S65_init()
Declare Sub Window_locate(byval X_start As Byte , Byval Y_start As Byte , Byval X_end As Byte , Byval Y_end As Byte)
Declare Sub Cspulse()
Declare Sub Command_send(byval Nn As Byte)
Declare Sub Data_send(byval Aa As Word)
Declare Sub String_print(byval X As Byte , Byval Y As Byte , Byval Lcd_text As String , Byval Color As Word , Byval Fon As Word)
Declare Sub Sym_locate(byval X As Byte , Byval Y As Byte)
Declare Sub Lcd_digit_print(byval X As Byte , Byval Y As Byte , Digit As Word)
Declare Sub Bytein()
Declare Sub Page_read(byval Page_mem As Word)
Declare Sub Page_write(byval Page_mem As Word)
Declare Sub Buffer1_to_flash(byval Page_mem As Word)
Declare Sub Buffer1_write
'Reset Ddrd.1
'Reset Portd.1
' SPI    
Config Spi = Hard , Interrupt = On , Data Order = Msb , Master = Yes , Polarity = High , Phase = 1 , Clockrate = 4 , Noss = 1
Spiinit
Reset Spcr.spr1 : Reset Spcr.spr0 : Set Spsr.spi2x
' SPI
Call S65_init



Call Clear_screen(black)
Set Cs


C = 1
Temp1 = 1
U = 140

$asm
.def Temp = R16
.def Out1 = R18
.def Out2 = R19
 clr r0
ldi yh,$20
ldi yl,$00
ldi r17,255
$end Asm

While Pind.2 = 1
Wend

sei
sbi eimsk,2


Do
If End_cadr = 0 Then
cli
Decr U
If U = 0 Then Gosub Show_kadr

If Menu_knop = 0 Then Gosub Menu
If Sel = 0 Then Set Select_cadr
End_cadr = 1

sei
End If
Loop


'-----------------------------------------------------------------------------------------------------------------------
Show_kadr:
Disable Interrupts
Disable Int0
Disable Int1

Set Cs
Call Window_locate(1 , 1 , 128 , 140)

$asm
ldi yh,$20
ldi yl,$00
$end Asm

For N = 1 To 140
$asm
ldi r24,128
Dr:
  ld r23,y+
 '--------------

 '--------------
' - - - - - - - - - - - - - -
  cpi r23,200
  brlo wt
  ldi r23,200
Wt:
     mov temp,r23
     !Swap Temp
     lsr     temp
     andi temp,$7
     mov out1,r23
    andi out1,$f9
   add out1,temp
'--------------
!out spdr,out1
Waih:
  sbis spsr, spif
  rjmp waih
     mov out2,r23
     lsr out2
     lsr out2
     lsr out2
     lsr r23
    !swap r23

      andi  r23,$e0
      andi  out2,$1f
      add out2,temp
      !out spdr,out2
Wapih:
  sbis spsr, spif
  rjmp wapih

  ld r23,y+
  dec r24
  brne  DR
  $end Asm
  Next N
  Set Cs
  $asm
  ldi r17,255
  ldi yh,$20
  ldi yl,$00
  $end Asm
U = 140
If Select_cadr = 1 Then
Reset Select_cadr
Number_cadr = 1
Gosub Im_lcd
End If
While Pind.2 = 1
Wend
Return


Menu:
While Sel = 0
Wend
Waitms 10
Call String_print(1 , 141 , "Return to camera" , Blue , Green)
Call String_print(16 , 157 , "Save to memory" , Blue , Black)
While Menu_knop = 0
Wend
Waitms 10
Loop_menu:
If Menu_knop = 0 Then Goto Vozvrat
If Sel = 0 Then Goto Mem_save
Goto Loop_menu
Vozvrat:
Call Clear_screen(black)
Return
Mem_save:
While Sel = 0
Wend
Waitms 10
Call String_print(1 , 141 , "Return to camera" , Blue , Black)
Call String_print(16 , 157 , "Save to memory" , Blue , Green)
While Menu_knop = 0
Wend
Waitms 10
Loop_menu_2:
If Menu_knop = 0 Then Goto Memory_save
If Sel = 0 Then Goto Menu
Goto Loop_menu_2


Memory_save:
N = 1
Color = Green
Call Clear_screen(black)
Number_cadr = 1
For Y = 159 To 56 Step -17
Call String_print(2 , Y , "Cadr" , Blue , Black)
Call Lcd_digit_print(40 , Y , Number_cadr)
Incr Number_cadr
Next Y

For Y = 159 To 56 Step -17
Call String_print(76 , Y , "Cadr" , Blue , Black)
Call Lcd_digit_print(116 , Y , Number_cadr)
Incr Number_cadr
Next Y
Number_cadr = 1
Gosub Light_str
Op:
If Sel = 0 Then
If Number_cadr = 14 Then
Number_cadr = 1
Call String_print(76 , 57 , "Cadr" , Blue , Black)
 Else
Incr Number_cadr
End If
Gosub Light_str
While Sel = 0 : Wend
Waitms 10
End If
If Menu_knop = 0 Then
Gosub Buf_to_flash
Goto Vozvrat
End If
Goto Op


Light_str:
Select Case Number_cadr
Case 1 : Y = 159
Case 2 : Y = 142
Case 3 : Y = 125
Case 4 : Y = 108
Case 5 : Y = 91
Case 6 : Y = 74
Case 7 : Y = 57
Case 8 : Y = 159
Case 9 : Y = 142
Case 10 : Y = 125
Case 11 : Y = 108
Case 12 : Y = 91
Case 13 : Y = 74
Case 14 : Y = 57
End Select

If Number_cadr < 8 Then
Call String_print(2 , Y , "Cadr" , Blue , Green)
Else
Call String_print(2 , 57 , "Cadr" , Blue , Black)
Call String_print(76 , Y , "Cadr" , Blue , Green)
End If

If Y = 159 Then
Goto Svalil
Else
Y = Y + 17
If Number_cadr < 8 Then
Call String_print(2 , Y , "Cadr" , Blue , Black)
Else
Call String_print(76 , Y , "Cadr" , Blue , Black)
End If
Svalil:
Return
End If

End



'------------------------------------------
'###############################################################################
Sub Cspulse                                                 '  CS
  Set Cs
  nop
  Reset Cs
End Sub

'------------   ---------------------------
Sub Command_send(byval Nn As Byte)                          ' 
N = &H74
Call Byteout()
N = 0
Call Byteout()
N = Nn
Call Byteout()
Call Cspulse
End Sub
'----------   ------------------------------
Sub Data_send(byval Aa As Word)                             ' 
N = &H76
Call Byteout()
A = Aa
Call Wordout()
Call Cspulse
End Sub
'--------       ----------------
Sub Wordout
      lds r23, {a+1}
      !out spdr, r23
      lds r23, {a}
Wait_trh:
      sbis spsr, spif
      rjmp wait_trh
      !out spdr, r23
Wait_trl:
      sbis spsr, spif
      rjmp wait_trl
End Sub

'-------------    --------------------------
Sub Byteout
      lds r23, {n}
      !out spdr, r23
 Waitresult:
      sbis spsr, spif
      rjmp waitresult
End Sub

'-----------      --------------
 Sub Lcd_digit_print(byval X As Byte , Byval Y As Byte , Digit As Word)
 Dim Xs As Byte , Temp3 As Word
 Xs = X
 Dim Digit$ As String * 1
 Temp3 = Digit

 While Temp3 > 0

 Dig = Temp3 Mod 10
 Select Case Dig
Case 0 : Digit$ = "0"
Case 1 : Digit$ = "1"
Case 2 : Digit$ = "2"
Case 3 : Digit$ = "3"
Case 4 : Digit$ = "4"
Case 5 : Digit$ = "5"
Case 6 : Digit$ = "6"
Case 7 : Digit$ = "7"
Case 8 : Digit$ = "8"
Case 9 : Digit$ = "9"
End Select
Call String_print(xs , Y , Digit$ , Color , Fon )
Xs = Xs + 8
Temp3 = Temp3 / 10
Wend

 End Sub

'-------------------------------------------------------------------------------
Sub S65_init
Reset Rst
Set Cs
Set Rs
Waitms 1
Set Rst
Waitms 10
Reset Cs
Restore Ini_code
For Temp = 0 To 33
Read N
Call Command_send(n)
Read A
Call Data_send(a)
Next Temp
Waitms 300
Set Cs
End Sub
'-------------------------------------------------------------------------------
Sub Sym_locate(byval X As Byte , Byval Y As Byte)

X_end = X + 7
Y_end = Y + 13

Call Window_locate(x , Y , X_end , Y_end)

End Sub
'-------------------------------------------------------------------------------

Sub Clear_screen(clear_color As Word)
Dim Temp2 As Word

Reset Cs

Call Command_send(&H16)
Call Data_send(&H8400)                                      '    (131)   
Call Command_send(&H17)
Call Data_send(&Haf00)
Call Command_send(&H21)                                     '   ,    
Call Data_send(&H0)
Call Command_send(&H22)
N = &H76
Call Byteout()
A = Clear_color

For Temp2 = 1 To 46464
Call Wordout()
Next Temp2

End Sub

Sub Window_locate(x As Byte , Y As Byte , X_pixel As Byte , Y_pixel As Byte)
Reset Cs

Call Command_send(&H16)

N = &H76
Call Byteout()
N = X_end
Call Byteout()
N = X_start
Call Byteout()
Call Cspulse

Call Command_send(&H17)
N = &H76
Call Byteout()
N = Y_end
Call Byteout()
N = Y_start
Call Byteout()
Call Cspulse


Call Command_send(&H21)
N = &H76
Call Byteout()
N = Y_start
Call Byteout()
N = X_start
Call Byteout()
Call Cspulse

Call Command_send(&H22)
N = &H76
Call Byteout()
End Sub

'-------------------------------------------------------------------------------
Sub Page_read(byval Page_mem As Word)
'-------------Flash read subroutine---------------------------------------------
'    
'-------page_Mem (0-2047)
'------buf(264)  264 
Reset Select_memory                                         'select flash ram
N = Current_page_read                                       'command Current_page_read
Call Byteout()                                              'out 3 bytes of adress
Shift Page_mem , Left , 1

A = Page_mem
Call Wordout()
N = 0
Call Byteout()
'-------------
Call Byteout()
Call Byteout()
Call Byteout()
Call Byteout()
' 32 dont care bits
For Temp1 = 1 To 264
Call Bytein()
Buf(temp1) = N
Next Temp1
Set Select_memory
End Sub

Sub Bytein()
      ldi r23,0
      !Out Spdr , R23
Wairh:
      sbis spsr, spif
      rjmp wairh
      in r23,spdr
      sts  {n},r23
End Sub

Sub Buffer1_to_flash(byval Page_mem As Word)
'-------------Flash write subroutine---------------------------------------------
'   1   
'-------page_Mem (0-2047)
Reset Select_memory
N = Buff1_mem_write                                         ' command write buffer to flash
Call Byteout()
Shift Page_mem , Left , 1

A = Page_mem
Call Wordout()
N = 0
Call Byteout()
Set Select_memory                                           'deselect memory
Waitms 30
End Sub


Sub Buffer1_write
Reset Select_memory
N = Buff1_write                                             ' command write in buffer
Call Byteout()
N = &H00                                                    '
Call Byteout()
N = &H00                                                    '
Call Byteout()
N = &H00                                                    '
Call Byteout()
'Set Select_memory
End Sub




Sub Page_write(page_mem As Word)
Reset Select_memory
N = Current_page_write                                      ' command write buffer to flash
Call Byteout()
Shift Page_mem , Left , 1
A = Page_mem
Call Wordout()
N = 0
Call Byteout()

'             'deselect memory
'Waitms 30
End Sub
Ini_code:
Data &H07 , &H0000% , &H02 , &H0400% , &H04 , &H0000% , &H0C , &H0001% , &H0D , &H0616% , &H0E , &H1010%
Data &H03 , &H000C% , &H0E , &H2D1F% , &H0D , &H0616% , &H01 , &H0215% , &H0F , &H0000% , &H0B , &H0000%
Data &H11 , &H0000% , &H06 , &H0000% , &H05 , &H0030% , &H14 , &HAF00% , &H15 , &H0000% , &H16 , &H8300%
Data &H17 , &HAF00% , &H20 , &H0000% , &H30 , &H0000% , &H31 , &H0400%
Data &H32 , &H0207% , &H33 , &H0700% , &H34 , &H0005% , &H35 , &H0703% , &H36 , &H0707% , &H37 , &H0007%
Data &H3A , &H1200% , &H3B , &H0009% , &H07 , &H0005% , &H07 , &H0025% , &H07 , &H0027% , &H07 , &H0037%



Sub String_print(byval X As Byte , Byval Y As Byte , Byval Lcd_text As String * 22 , Byval Color As Word , Byval Fon As Word)
Dim String_length As Byte
       Call Sym_locate(x , Y)
      For String_length = Len(lcd_text) To 1 Step -1        '   

      Symbol = Mid(lcd_text , String_length , 1)

      G = Asc(symbol)                                       '  
      G = G - 32
      G = G * 14
      G = G + 14                                            '   
      Readeeprom B , G                                      '     
      For F = 1 To 14                                       '  14   
      D = B                                                 '     
            For E = 1 To 8                                  '  8   x
               Ae = D And 1                                 '    x
               If Ae = 1 Then
                  A = Color                                 ' 1
                  Call Wordout()
               Else
                  A = Fon
                  Call Wordout()
               End If
               Shift D , Right , 1                          ' ,     
            Next E
          G = G - 1                                         '   
         Readeeprom B , G                                   '   
      Next F
      Set Cs                                                '                                                  '
      X = X + 8
      Call Sym_locate(x , Y)
      Next String_length
      Set Cs
      End Sub

Data_reqest:

$asm
in r23,pinf
st y+,r23
dec r17
breq ALL
'nop
'nop
'nop
'nop

reti

All:
'Reset Portd.6
cbi eimsk,0
sts {end_cadr},r0
Reti
$end Asm
Hsyncro:
'sbi portd,6
Enable Int0
Return

Kadr:
While Pind.1 = 1
Wend
Enable Int1

Return

'-------------------------------------------------------------------------------
'---------------------    --------------------------
'-------------------------------------------------------------------------------

Buf_to_flash:
Gosub Select_page
$asm
ldi yh,$20
ldi yl,$00
$end Asm

Set Reset_memory
Buf_zikl = Page_mem + 140                                   '
For Word_temp = Page_mem To Buf_zikl
Call Buffer1_write

For Temp1 = 1 To 128
$asm
ld r23,y+
sts {n},r23
$end Asm
Call Byteout()
$asm
ld r23,y+
sts {n},r23
$end Asm
Call Byteout()
Next Temp1

Set Select_memory

Call Buffer1_to_flash(word_temp)                            '    temp5
Next Word_temp

Reset Reset_memory
$asm
ldi yh,$20
ldi yl,$00
$end Asm
Return

Select_page:
Select Case Number_cadr
Case 1 : Page_mem = 1
Case 2 : Page_mem = 141
Case 3 : Page_mem = 281
Case 4 : Page_mem = 421
Case 5 : Page_mem = 561
Case 6 : Page_mem = 701
Case 7 : Page_mem = 841
Case 8 : Page_mem = 981
Case 9 : Page_mem = 1121
Case 10 : Page_mem = 1261
Case 11 : Page_mem = 1401
Case 12 : Page_mem = 1541
Case 13 : Page_mem = 1681
Case 14 : Page_mem = 1821
End Select
Return
'-------------------------------------------------------------------------------
'-------------------------------------------------------------------------------
'-------------------------------------------------------------------------------


Im_lcd:
Call Clear_screen(black)
Gosub Select_page

Set Cs
 $asm
ldi yh,$20
ldi yl,$00
 $end Asm
Set Reset_memory                                            '
Y = 1
Buf_zikl = Page_mem + 140                                   '
For Word_temp = Page_mem To Buf_zikl

Call Page_read(word_temp)
B = Y + 1
Temp1 = 1
For A = 1 To 246 Step 2                                     'Step 2

N = Buf(temp1)
$asm
lds r23,{n}
st y+,r23
$end Asm
Incr Temp1

N = Buf(temp1)
$asm
lds r23,{n}
st y+,r23
$end Asm
Incr Temp1
Next Temp1
Next Word_temp


Call Window_locate(1 , 1 , 123 , 140)

$asm
ldi yh,$20
ldi yl,$00
$end Asm

For N = 1 To 140
$asm
ldi r24,128
Drt:
  ld r23,y+
 '--------------

 '--------------
' - - - - - - - - - - - - - -
  cpi r23,200
  brlo wtt
  ldi r23,200
Wtt:
     mov temp,r23
     !Swap Temp
     lsr     temp
     andi temp,$7
     mov out1,r23
    andi out1,$f9
   add out1,temp
'--------------
!out spdr,out1
Waiht:
  sbis spsr, spif
  rjmp waiht
     mov out2,r23
     lsr out2
     lsr out2
     lsr out2
     lsr r23
    !swap r23

      andi  r23,$e0
      andi  out2,$1f
      add out2,temp
      !out spdr,out2
Wapiht:
  sbis spsr, spif
  rjmp wapiht

  ld r23,y+
  dec r24
  brne  DRt
  $end Asm
  Next N
  Set Cs
  $asm
  ldi r17,255
  ldi yh,$20
  ldi yl,$00
  $end Asm
  Color = Blue
Call String_print(41 , 141 , "Sel - next" , Blue , Black)
Call Lcd_digit_print(8 , 141 , Number_cadr)
Call String_print(16 , 157 , "Menu - camera" , Blue , Black)

Aa:
If Sel = 0 Then
Incr Number_cadr
If Number_cadr = 15 Then Number_cadr = 1
While Sel = 0 : Wend
Waitms 10
Goto Im_lcd
End If

If Menu_knop = 0 Then
Call Clear_screen(black)
While Menu_knop = 0 : Wend
Waitms 10
Goto Ab
End If
Goto Aa
Ab:
Return
'-------------------------------------------------------------------------------
'-------------------------------------------------------------------------------
'-------------------------------------------------------------------------------
'$include "mar.bas"
$eeprom

 Data &H00 , &H00 , &H00 , &H00 , &H00 , &H00 , &H00 , &H00 , &H00 , &H00 , &H00 , &H00 , &H00 , &H00
 Data &H00 , &H00 , &H00 , &H18 , &H3C , &H3C , &H3C , &H18 , &H18 , &H00 , &H18 , &H18 , &H00 , &H00
 Data &H00 , &H66 , &H66 , &H66 , &H24 , &H00 , &H00 , &H00 , &H00 , &H00 , &H00 , &H00 , &H00 , &H00
 Data &H00 , &H00 , &H00 , &H6C , &H6C , &HFE , &H6C , &H6C , &H6C , &HFE , &H6C , &H6C , &H00 , &H00
 Data &H00 , &H18 , &H18 , &H7C , &HC6 , &HC2 , &HC0 , &H7C , &H06 , &H86 , &HC6 , &H7C , &H18 , &H18
 Data &H00 , &H00 , &H00 , &H00 , &H00 , &HC2 , &HC6 , &H0C , &H18 , &H30 , &H66 , &HC6 , &H00 , &H00
 Data &H00 , &H00 , &H00 , &H38 , &H6C , &H6C , &H38 , &H76 , &HDC , &HCC , &HCC , &H76 , &H00 , &H00
 Data &H00 , &H18 , &H18 , &H18 , &H30 , &H00 , &H00 , &H00 , &H00 , &H00 , &H00 , &H00 , &H00 , &H00
 Data &H00 , &H00 , &H00 , &H0C , &H18 , &H30 , &H30 , &H30 , &H30 , &H30 , &H18 , &H0C , &H00 , &H00
 Data &H00 , &H00 , &H00 , &H30 , &H18 , &H0C , &H0C , &H0C , &H0C , &H0C , &H18 , &H30 , &H00 , &H00
 Data &H00 , &H00 , &H00 , &H00 , &H00 , &H66 , &H3C , &HFF , &H3C , &H66 , &H00 , &H00 , &H00 , &H00
 Data &H00 , &H00 , &H00 , &H00 , &H00 , &H18 , &H18 , &H7E , &H18 , &H18 , &H00 , &H00 , &H00 , &H00
 Data &H00 , &H00 , &H00 , &H00 , &H00 , &H00 , &H00 , &H00 , &H00 , &H18 , &H18 , &H18 , &H30 , &H00
 Data &H00 , &H00 , &H00 , &H00 , &H00 , &H00 , &H00 , &HFE , &H00 , &H00 , &H00 , &H00 , &H00 , &H00
 Data &H00 , &H00 , &H00 , &H00 , &H00 , &H00 , &H00 , &H00 , &H00 , &H00 , &H18 , &H18 , &H00 , &H00
 Data &H00 , &H00 , &H00 , &H02 , &H06 , &H0C , &H18 , &H30 , &H60 , &HC0 , &H80 , &H00 , &H00 , &H00
 Data &H00 , &H00 , &H00 , &H38 , &H6C , &HC6 , &HC6 , &HD6 , &HC6 , &HC6 , &H6C , &H38 , &H00 , &H00
 Data &H00 , &H00 , &H00 , &H18 , &H38 , &H78 , &H18 , &H18 , &H18 , &H18 , &H18 , &H7E , &H00 , &H00
 Data &H00 , &H00 , &H00 , &H7C , &HC6 , &H06 , &H0C , &H18 , &H30 , &H60 , &HC6 , &HFE , &H00 , &H00
 Data &H00 , &H00 , &H00 , &H7C , &HC6 , &H06 , &H06 , &H3C , &H06 , &H06 , &HC6 , &H7C , &H00 , &H00
 Data &H00 , &H00 , &H00 , &H0C , &H1C , &H3C , &H6C , &HCC , &HFE , &H0C , &H0C , &H1E , &H00 , &H00
 Data &H00 , &H00 , &H00 , &HFE , &HC0 , &HC0 , &HC0 , &HFC , &H06 , &H06 , &HC6 , &H7C , &H00 , &H00
 Data &H00 , &H00 , &H00 , &H38 , &H60 , &HC0 , &HC0 , &HFC , &HC6 , &HC6 , &HC6 , &H7C , &H00 , &H00
 Data &H00 , &H00 , &H00 , &HFE , &HC6 , &H06 , &H0C , &H18 , &H30 , &H30 , &H30 , &H30 , &H00 , &H00
 Data &H00 , &H00 , &H00 , &H7C , &HC6 , &HC6 , &HC6 , &H7C , &HC6 , &HC6 , &HC6 , &H7C , &H00 , &H00
 Data &H00 , &H00 , &H00 , &H7C , &HC6 , &HC6 , &HC6 , &H7E , &H06 , &H06 , &H0C , &H78 , &H00 , &H00
 Data &H00 , &H00 , &H00 , &H00 , &H18 , &H18 , &H00 , &H00 , &H00 , &H18 , &H18 , &H00 , &H00 , &H00
 Data &H00 , &H00 , &H00 , &H00 , &H18 , &H18 , &H00 , &H00 , &H00 , &H18 , &H18 , &H30 , &H00 , &H00
 Data &H00 , &H00 , &H00 , &H0C , &H18 , &H30 , &H60 , &HC0 , &H60 , &H30 , &H18 , &H0C , &H00 , &H00
 Data &H00 , &H00 , &H00 , &H00 , &H00 , &H00 , &H7E , &H00 , &H00 , &H7E , &H00 , &H00 , &H00 , &H00
 Data &H00 , &H00 , &H00 , &H60 , &H30 , &H18 , &H0C , &H06 , &H0C , &H18 , &H30 , &H60 , &H00 , &H00
 Data &H00 , &H00 , &H00 , &H7C , &HC6 , &HC6 , &H0C , &H18 , &H18 , &H00 , &H18 , &H18 , &H00 , &H00
 Data &H00 , &H00 , &H00 , &H7C , &HC6 , &HC6 , &HDE , &HDE , &HDE , &HDC , &HC0 , &H7C , &H00 , &H00
 Data &H00 , &H00 , &H00 , &H10 , &H38 , &H6C , &HC6 , &HC6 , &HFE , &HC6 , &HC6 , &HC6 , &H00 , &H00
 Data &H00 , &H00 , &H00 , &HFC , &H66 , &H66 , &H66 , &H7C , &H66 , &H66 , &H66 , &HFC , &H00 , &H00
 Data &H00 , &H00 , &H00 , &H3C , &H66 , &HC2 , &HC0 , &HC0 , &HC0 , &HC2 , &H66 , &H3C , &H00 , &H00
 Data &H00 , &H00 , &H00 , &HF8 , &H6C , &H66 , &H66 , &H66 , &H66 , &H66 , &H6C , &HF8 , &H00 , &H00
 Data &H00 , &H00 , &H00 , &HFE , &H66 , &H62 , &H68 , &H78 , &H68 , &H62 , &H66 , &HFE , &H00 , &H00
 Data &H00 , &H00 , &H00 , &HFE , &H66 , &H62 , &H68 , &H78 , &H68 , &H60 , &H60 , &HF0 , &H00 , &H00
 Data &H00 , &H00 , &H00 , &H3C , &H66 , &HC2 , &HC0 , &HC0 , &HDE , &HC6 , &H66 , &H3A , &H00 , &H00
 Data &H00 , &H00 , &H00 , &HC6 , &HC6 , &HC6 , &HC6 , &HFE , &HC6 , &HC6 , &HC6 , &HC6 , &H00 , &H00
 Data &H00 , &H00 , &H00 , &H3C , &H18 , &H18 , &H18 , &H18 , &H18 , &H18 , &H18 , &H3C , &H00 , &H00
 Data &H00 , &H00 , &H00 , &H1E , &H0C , &H0C , &H0C , &H0C , &H0C , &HCC , &HCC , &H78 , &H00 , &H00
 Data &H00 , &H00 , &H00 , &HE6 , &H66 , &H6C , &H6C , &H78 , &H6C , &H6C , &H66 , &HE6 , &H00 , &H00
 Data &H00 , &H00 , &H00 , &HF0 , &H60 , &H60 , &H60 , &H60 , &H60 , &H62 , &H66 , &HFE , &H00 , &H00
 Data &H00 , &H00 , &H00 , &HC6 , &HEE , &HFE , &HD6 , &HC6 , &HC6 , &HC6 , &HC6 , &HC6 , &H00 , &H00
 Data &H00 , &H00 , &H00 , &HC6 , &HE6 , &HF6 , &HFE , &HDE , &HCE , &HC6 , &HC6 , &HC6 , &H00 , &H00
 Data &H00 , &H00 , &H00 , &H7C , &HC6 , &HC6 , &HC6 , &HC6 , &HC6 , &HC6 , &HC6 , &H7C , &H00 , &H00
 Data &H00 , &H00 , &H00 , &HFC , &H66 , &H66 , &H66 , &H7C , &H60 , &H60 , &H60 , &HF0 , &H00 , &H00
 Data &H00 , &H00 , &H00 , &H7C , &HC6 , &HC6 , &HC6 , &HC6 , &HC6 , &HD6 , &HDE , &H7C , &H0E , &H00
 Data &H00 , &H00 , &H00 , &HFC , &H66 , &H66 , &H66 , &H7C , &H6C , &H66 , &H66 , &HE6 , &H00 , &H00
 Data &H00 , &H00 , &H00 , &H7C , &HC6 , &HC6 , &H60 , &H38 , &H0C , &HC6 , &HC6 , &H7C , &H00 , &H00
 Data &H00 , &H00 , &H00 , &H7E , &H7E , &H5A , &H18 , &H18 , &H18 , &H18 , &H18 , &H3C , &H00 , &H00
 Data &H00 , &H00 , &H00 , &HC6 , &HC6 , &HC6 , &HC6 , &HC6 , &HC6 , &HC6 , &HC6 , &H7C , &H00 , &H00
 Data &H00 , &H00 , &H00 , &HC6 , &HC6 , &HC6 , &HC6 , &HC6 , &HC6 , &H6C , &H38 , &H10 , &H00 , &H00
 Data &H00 , &H00 , &H00 , &HC6 , &HC6 , &HC6 , &HC6 , &HD6 , &HD6 , &HFE , &H6C , &H6C , &H00 , &H00
 Data &H00 , &H00 , &H00 , &HC6 , &HC6 , &HC6 , &H7C , &H38 , &H7C , &HC6 , &HC6 , &HC6 , &H00 , &H00
 Data &H00 , &H00 , &H00 , &H66 , &H66 , &H66 , &H66 , &H3C , &H18 , &H18 , &H18 , &H3C , &H00 , &H00
 Data &H00 , &H00 , &H00 , &HFE , &HC6 , &H8C , &H18 , &H30 , &H60 , &HC2 , &HC6 , &HFE , &H00 , &H00
 Data &H00 , &H00 , &H00 , &H3C , &H30 , &H30 , &H30 , &H30 , &H30 , &H30 , &H30 , &H3C , &H00 , &H00
 Data &H00 , &H00 , &H00 , &H80 , &HC0 , &HE0 , &H70 , &H38 , &H1C , &H0E , &H06 , &H02 , &H00 , &H00
 Data &H00 , &H00 , &H00 , &H3C , &H0C , &H0C , &H0C , &H0C , &H0C , &H0C , &H0C , &H3C , &H00 , &H00
 Data &H10 , &H38 , &H6C , &HC6 , &H00 , &H00 , &H00 , &H00 , &H00 , &H00 , &H00 , &H00 , &H00 , &H00
 Data &H00 , &H00 , &H00 , &H00 , &H00 , &H00 , &H00 , &H00 , &H00 , &H00 , &H00 , &H00 , &H00 , &HFF
 Data &H00 , &H30 , &H18 , &H0C , &H00 , &H00 , &H00 , &H00 , &H00 , &H00 , &H00 , &H00 , &H00 , &H00
 Data &H00 , &H00 , &H00 , &H00 , &H00 , &H00 , &H78 , &H0C , &H7C , &HCC , &HCC , &H76 , &H00 , &H00
 Data &H00 , &H00 , &H00 , &HE0 , &H60 , &H60 , &H78 , &H6C , &H66 , &H66 , &H66 , &H7C , &H00 , &H00
 Data &H00 , &H00 , &H00 , &H00 , &H00 , &H00 , &H7C , &HC6 , &HC0 , &HC0 , &HC6 , &H7C , &H00 , &H00
 Data &H00 , &H00 , &H00 , &H1C , &H0C , &H0C , &H3C , &H6C , &HCC , &HCC , &HCC , &H76 , &H00 , &H00
 Data &H00 , &H00 , &H00 , &H00 , &H00 , &H00 , &H7C , &HC6 , &HFE , &HC0 , &HC6 , &H7C , &H00 , &H00
 Data &H00 , &H00 , &H00 , &H1C , &H36 , &H32 , &H30 , &H7C , &H30 , &H30 , &H30 , &H78 , &H00 , &H00
 Data &H00 , &H00 , &H00 , &H00 , &H00 , &H00 , &H76 , &HCC , &HCC , &HCC , &H7C , &H0C , &HCC , &H78
 Data &H00 , &H00 , &H00 , &HE0 , &H60 , &H60 , &H6C , &H76 , &H66 , &H66 , &H66 , &HE6 , &H00 , &H00
 Data &H00 , &H00 , &H00 , &H18 , &H18 , &H00 , &H38 , &H18 , &H18 , &H18 , &H18 , &H3C , &H00 , &H00
 Data &H00 , &H00 , &H00 , &H06 , &H06 , &H00 , &H0E , &H06 , &H06 , &H06 , &H06 , &H66 , &H66 , &H3C
 Data &H00 , &H00 , &H00 , &HE0 , &H60 , &H60 , &H66 , &H6C , &H78 , &H6C , &H66 , &HE6 , &H00 , &H00
 Data &H00 , &H00 , &H00 , &H38 , &H18 , &H18 , &H18 , &H18 , &H18 , &H18 , &H18 , &H3C , &H00 , &H00
 Data &H00 , &H00 , &H00 , &H00 , &H00 , &H00 , &HEC , &HFE , &HD6 , &HD6 , &HD6 , &HD6 , &H00 , &H00
 Data &H00 , &H00 , &H00 , &H00 , &H00 , &H00 , &HDC , &H66 , &H66 , &H66 , &H66 , &H66 , &H00 , &H00
 Data &H00 , &H00 , &H00 , &H00 , &H00 , &H00 , &H7C , &HC6 , &HC6 , &HC6 , &HC6 , &H7C , &H00 , &H00
 Data &H00 , &H00 , &H00 , &H00 , &H00 , &H00 , &HDC , &H66 , &H66 , &H66 , &H7C , &H60 , &H60 , &HF0
 Data &H00 , &H00 , &H00 , &H00 , &H00 , &H00 , &H76 , &HCC , &HCC , &HCC , &H7C , &H0C , &H0C , &H1E
 Data &H00 , &H00 , &H00 , &H00 , &H00 , &H00 , &HDC , &H76 , &H66 , &H60 , &H60 , &HF0 , &H00 , &H00
 Data &H00 , &H00 , &H00 , &H00 , &H00 , &H00 , &H7C , &HC6 , &H70 , &H1C , &HC6 , &H7C , &H00 , &H00
 Data &H00 , &H00 , &H00 , &H10 , &H30 , &H30 , &HFC , &H30 , &H30 , &H30 , &H36 , &H1C , &H00 , &H00
 Data &H00 , &H00 , &H00 , &H00 , &H00 , &H00 , &HCC , &HCC , &HCC , &HCC , &HCC , &H76 , &H00 , &H00
 Data &H00 , &H00 , &H00 , &H00 , &H00 , &H00 , &HC6 , &HC6 , &HC6 , &H6C , &H38 , &H10 , &H00 , &H00
 Data &H00 , &H00 , &H00 , &H00 , &H00 , &H00 , &HC6 , &HC6 , &HD6 , &HD6 , &HFE , &H6C , &H00 , &H00
 Data &H00 , &H00 , &H00 , &H00 , &H00 , &H00 , &HC6 , &H6C , &H38 , &H38 , &H6C , &HC6 , &H00 , &H00
 Data &H00 , &H00 , &H00 , &H00 , &H00 , &H00 , &HC6 , &HC6 , &HC6 , &HC6 , &H7E , &H06 , &H0C , &H78
 Data &H00 , &H00 , &H00 , &H00 , &H00 , &H00 , &HFE , &HCC , &H18 , &H30 , &H66 , &HFE , &H00 , &H00
 Data &H00 , &H00 , &H00 , &H0E , &H18 , &H18 , &H18 , &H70 , &H18 , &H18 , &H18 , &H0E , &H00 , &H00
 Data &H00 , &H00 , &H00 , &H18 , &H18 , &H18 , &H18 , &H18 , &H18 , &H18 , &H18 , &H18 , &H00 , &H00
 Data &H00 , &H00 , &H00 , &H70 , &H18 , &H18 , &H18 , &H0E , &H18 , &H18 , &H18 , &H70 , &H00 , &H00
 Data &H00 , &H76 , &HDC , &H00 , &H00 , &H00 , &H00 , &H00 , &H00 , &H00 , &H00 , &H00 , &H00 , &H00
 Data &H00 , &H00 , &H00 , &H00 , &H00 , &H10 , &H38 , &H6C , &HC6 , &HC6 , &HFE , &H00 , &H00 , &H00